//  common.h 
//
// definitions common to the entire project
//

/*
 * Licensed Materials - Property of IBM
 * 5648-C63
 * (C) Copyright IBM Corp. 2001
 */

// allow for Unix systems
#ifndef INT_MAX
#define INT_MAX 2147483647
#endif

#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif
#ifndef UNKNOWN
#define UNKNOWN	-1
#endif

#define COMPLETE_BIT	1
#define DELIMITER		0x01
#define chPeriod		0x2E
#define chYes			0x59
#define chNo			0x4E
#define chUndefined		0x55
#define MGMT_MSG		"SYSTMGMT"
#define MAX_TAG_LEN		5			/* maximum length of FIX identifier */

#define PARSER_CLASS	L"FIX"
#define PARSER_CLASS2	L"FIXONLY"
#define	PARSER_NAME		L"FixParserFactory"
#define TOP_LEVEL_NAME	L"FIX"
#define ERRDICT			L"fixerr"
#define FIX_NAME_START	L"FX"
#define MULTI_SEG_NAME	L"Val"
#define BEGIN_STRING	L"8="
#define MESSAGE_LENGTH	L"9="
#define CHECK_SUM		L"10="
#define CHECK_SUM_LEN	3
#define BEGINSTRING		L"BeginString"
#define BODYLENGTH		L"BodyLength"
#define FX8				L"FX8"
#define FX9				L"FX9"
#define STR_SPACE		L" "
#define STR_EQUAL_SIGN	L"="
#define DEFAULT_VERSION	L"FIX.4.2"
#define ENCRYPT_NAME	L"Encrypt"
#define ENCRYPT_NAME_LEN	7

#define NO_ENCRYPT_DOMAIN	"FIXONLY"
#define META_FILE_EXT		".mtx"
#define BEGIN_STRING_IDENT	"8"
#define MSG_LENGTH_IDENT	"9"
#define CHECK_SUM_TAG		"10="
#define DEFAULT_LEVEL		"FIX42"

#define METADATADIRENV	"FIXMETADIR"
#define TRACEALLENV		"FIXTRACEALL"
#define TRACEFILEENV	"FIXTRACEFILE"
#define TRACEPARSERENV	"FIXTRACEPARSER"
#define TRACEWRITEENV	"FIXTRACEWRITE"
#define TRACEMODULEENV	"FIXTRACEMODULE"
#define TRACEMGMTENV	"FIXTRACEMGMT"

#ifdef WIN32
#define METADATA_DIR_DEF    "C:\\fix"
#define TRACEFILEDEF		"C:\\fix\\Parser.trc"
#else
#define METADATA_DIR_DEF    "/var/fix/"
#define TRACEFILEDEF		"/tmp/Parser.trc"
#endif

#ifdef WIN32
#define DEF_CODEPAGE	437
#define DEF_ENCODING	546
#define SLASHCHAR		'\\'
#define SLASHCHARSTR	"\\"
#elif defined _AIX
#define DEF_CODEPAGE	850
#define DEF_ENCODING	273
#define SLASHCHAR		'/'
#define SLASHCHARSTR	"/"
#else
#define DEF_CODEPAGE	850
#define DEF_ENCODING	273
#define SLASHCHAR		'/'
#define SLASHCHARSTR	"/"
#endif
