#ifndef FixContext_h
#define FixContext_h

#include <BipCpi.h>

#define MAX_DOM	33
#define MAX_SET	33
#define MAX_VER	33
#define MAX_FIX	32

typedef struct {
	void*			nextItem;
	int				rptnum;
	CciChar*		topName;
	CciChar*		typePtr;
	CciChar*		members;
} RPT_ITEM;

typedef struct {
	unsigned char*	iInput;				/* Original buffer pointer */
	unsigned char*	iOutput;			/* Pointer to output buffer */
	CciChar*		iBuffer;			/* Buffer pointer - Unicode */
	CciChar*		iPrevTag;			/* Pointer to previous tag */
	CciChar*		iPrevData;			/* Pointer to previous data area */
	int				iPrevDataType;		/* Type of previous data element */
	int				iSize;				/* Size of input buffer in bytes */
	int				iLength;			/* Length of output buffer in bytes */
	int				iIndex;				/* Current position in the buffer */
	int				iRemaining;			/* Remaining positions in output buffer */
	char			iCurrentCharacter;	/* The current character */
#ifdef WIN32
	__int64			iStartTime;			/* Measurement start time */
	__int64			totalParseTime;		/* Total time spent parsing this message in microsecs */
#else
	timebasestruct_t iStartTime;		/* Measurement start time */
	long long		totalParseTime;		/* Total time spent parsing this message in microsecs */
#endif
	int				iBadMsg;			/* Bad message flag - used to suppress statistics */
	int				iMsgType;			/* Management or regular message */
	int				iCodePage;			/* Code page */
	int				iEncoding;			/* Numeric format from MQMD */
	int				iUseEncryption;		/* Call encryption/decryption routines */
	RPT_ITEM		*iRepeat;			/* pointer to repeating item structure */
	CciElement		*eCurrentElement;	/* Current element */
	CciElement		*eBody;				/* Top level element pointer */
	void			*iEncryptionData;	/* Pointer reserved for encrypt/decrypt routines */
	char			sMsgType[MAX_FIX];	/* Fix message type */
	char			sLevelName[MAX_FIX];/* Fix Message standard level */
	char			msgDomain[MAX_DOM];	/* Domain name */
	char			msgSet[MAX_SET];	/* MessageSet property */
	char			msgType[MAX_VER];	/* MessageType property */
} PARSER_CONTEXT_ST;

#endif