//  comsubs.c 

/*
 * Licensed Materials - Property of IBM
 * 5648-C63
 * (C) Copyright IBM Corp. 2000
 */

/**************************************************************/
/*                                                            */
/* Program Name:  COMSUBS.C                                   */
/*                                                            */
/*  Common subroutines used in various programs.              */
/*                                                            */
/*  Written by Jim MacNair - September, 2000                  */
/*                                                            */
/**************************************************************/

#include <string.h>

static char HEXTABLE[] = "0123456789ABCDEF";

/**************************************************************/
/*                                                            */
/* This routine skips blanks in a string                      */
/*                                                            */
/**************************************************************/

char * skipBlanks(char *str)

{
   while (*str == ' ')
   {
      str++;
   } /* endwhile */

   return str;
}

/**************************************************************/
/*                                                            */
/* This routine finds the next blank in a string              */
/*                                                            */
/**************************************************************/

char * findBlank(char *str)

{
   while ((str[0] != ' ') && (str[0] != 0))
   {
      str++;
   } /* endwhile */

   return str;
}

/**************************************************************/
/*                                                            */
/* This routine will change any occurances of the specified   */
/* character into a blank.                                    */
/*                                                            */
/**************************************************************/

void changeChar(char *inStr, char oldch, char newch)

{
	char	*tempptr;

	tempptr = strchr(inStr, oldch);
	while (tempptr != NULL)
	{
		tempptr[0] = newch;
		tempptr = strchr(tempptr,oldch);
	}
}

/*******************************************************************/
/*                                                                 */
/*  Subroutine to convert the data to a hexidecimal                */
/*   representation.                                               */
/*                                                                 */
/*******************************************************************/

void buildHex(char *dataText, int len, const char *msgdata)

{
	int	i;
	int	j=0;
	char ch;

	for (i=0; i < len; i++)
	{
		ch = (unsigned char) msgdata[i] >> 4;
		ch = HEXTABLE[ch];
		//data2hex(&ch);
		dataText[j++] = ch;

		ch = (unsigned char) msgdata[i] & 0x0F;
		ch = HEXTABLE[ch];
		//data2hex(&ch);
		dataText[j++] = ch;
	}
}

/*****************************************************************/
/*                                                               */
/* Routine to check if a string is all numbers.  Will return 0   */
/* if the string is all numbers, otherwise returns a 1.          */
/*                                                               */
/*****************************************************************/

int isNumeric(char * dataArea)

{
	unsigned int i=0;

	while (i < strlen(dataArea))
	{
		if ((dataArea[i] < '0') || (dataArea[i] > '9'))
		{
			return 1;
		}
		else
		{
			i++;
		}
	}

	return 0;
}

